Loading...
Searching...
No Matches
her2k: Hermitian rank 2k update
Dense LA » MAGMA BLAS and Auxiliary » Level 3: matrix-matrix operations, O(n^3) work

\(C = \alpha A B^T + \alpha B A^T + \beta C\) where \(C\) is Hermitian More...

## Functions

void | magma_cher2k (magma_uplo_t uplo, magma_trans_t trans, magma_int_t n, magma_int_t k, magmaFloatComplex alpha, magmaFloatComplex_const_ptr dA, magma_int_t ldda, magmaFloatComplex_const_ptr dB, magma_int_t lddb, float beta, magmaFloatComplex_ptr dC, magma_int_t lddc, magma_queue_t queue)
| Perform Hermitian rank-2k update.
void | magma_zher2k (magma_uplo_t uplo, magma_trans_t trans, magma_int_t n, magma_int_t k, magmaDoubleComplex alpha, magmaDoubleComplex_const_ptr dA, magma_int_t ldda, magmaDoubleComplex_const_ptr dB, magma_int_t lddb, double beta, magmaDoubleComplex_ptr dC, magma_int_t lddc, magma_queue_t queue)
| Perform Hermitian rank-2k update.

void

magmablas_cher2k_mgpu2 (magma_uplo_t uplo, magma_trans_t trans, magma_int_t n, magma_int_t k, magmaFloatComplex alpha, magmaFloatComplex_ptr dA[], magma_int_t ldda, magma_int_t a_offset, magmaFloatComplex_ptr dB[], magma_int_t lddb, magma_int_t b_offset, float beta, magmaFloatComplex_ptr dC[], magma_int_t lddc, magma_int_t c_offset, magma_int_t ngpu, magma_int_t nb, magma_queue_t queues[][20], magma_int_t nqueue)

| CHER2K performs one of the Hermitian rank 2k operations.
void | magmablas_dsyr2k_mgpu2 (magma_uplo_t uplo, magma_trans_t trans, magma_int_t n, magma_int_t k, double alpha, magmaDouble_ptr dA[], magma_int_t ldda, magma_int_t a_offset, magmaDouble_ptr dB[], magma_int_t lddb, magma_int_t b_offset, double beta, magmaDouble_ptr dC[], magma_int_t lddc, magma_int_t c_offset, magma_int_t ngpu, magma_int_t nb, magma_queue_t queues[][20], magma_int_t nqueue)
| DSYR2K performs one of the symmetric rank 2k operations.
void | magmablas_ssyr2k_mgpu2 (magma_uplo_t uplo, magma_trans_t trans, magma_int_t n, magma_int_t k, float alpha, magmaFloat_ptr dA[], magma_int_t ldda, magma_int_t a_offset, magmaFloat_ptr dB[], magma_int_t lddb, magma_int_t b_offset, float beta, magmaFloat_ptr dC[], magma_int_t lddc, magma_int_t c_offset, magma_int_t ngpu, magma_int_t nb, magma_queue_t queues[][20], magma_int_t nqueue)
| SSYR2K performs one of the symmetric rank 2k operations.

void

magmablas_zher2k_mgpu2 (magma_uplo_t uplo, magma_trans_t trans, magma_int_t n, magma_int_t k, magmaDoubleComplex alpha, magmaDoubleComplex_ptr dA[], magma_int_t ldda, magma_int_t a_offset, magmaDoubleComplex_ptr dB[], magma_int_t lddb, magma_int_t b_offset, double beta, magmaDoubleComplex_ptr dC[], magma_int_t lddc, magma_int_t c_offset, magma_int_t ngpu, magma_int_t nb, magma_queue_t queues[][20], magma_int_t nqueue)

| ZHER2K performs one of the Hermitian rank 2k operations.

## Detailed Description

\(C = \alpha A B^T + \alpha B A^T + \beta C\) where \(C\) is Hermitian

## Function Documentation

## magma_cher2k()

void magma_cher2k | ( | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | magmaFloatComplex | alpha,
|  | magmaFloatComplex_const_ptr | dA,
|  | magma_int_t | ldda,
|  | magmaFloatComplex_const_ptr | dB,
|  | magma_int_t | lddb,
|  | float | beta,
|  | magmaFloatComplex_ptr | dC,
|  | magma_int_t | lddc,
|  | magma_queue_t | queue )

Perform Hermitian rank-2k update.

\( C = \alpha A B^H + \alpha B A^H \beta C \) (trans == MagmaNoTrans), or
\( C = \alpha A^H B + \alpha B^H A \beta C \) (trans == MagmaConjTrans),
where \( C \) is Hermitian.

Parameters

  [in] | uplo | Whether the upper or lower triangle of C is referenced.
  [in] | trans | Operation to perform on A and B.
  [in] | n | Number of rows and columns of C. n >= 0.
  [in] | k | Number of columns of A and B (for MagmaNoTrans) or rows of A and B (for MagmaConjTrans). k >= 0.
  [in] | alpha | Scalar \( \alpha \)
  [in] | dA | COMPLEX array on GPU device. If trans == MagmaNoTrans, the n-by-k matrix A of dimension (ldda,k), ldda >= max(1,n); otherwise, the k-by-n matrix A of dimension (ldda,n), ldda >= max(1,k).
  [in] | ldda | Leading dimension of dA.
  [in] | dB | COMPLEX array on GPU device. If trans == MagmaNoTrans, the n-by-k matrix B of dimension (lddb,k), lddb >= max(1,n); otherwise, the k-by-n matrix B of dimension (lddb,n), lddb >= max(1,k).
  [in] | lddb | Leading dimension of dB.
  [in] | beta | Scalar \( \beta \)
  [in,out] | dC | COMPLEX array on GPU device. The n-by-n Hermitian matrix C of dimension (lddc,n), lddc >= max(1,n).
  [in] | lddc | Leading dimension of dC.
  [in] | queue | magma_queue_t Queue to execute in.

## magma_zher2k()

void magma_zher2k | ( | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | magmaDoubleComplex | alpha,
|  | magmaDoubleComplex_const_ptr | dA,
|  | magma_int_t | ldda,
|  | magmaDoubleComplex_const_ptr | dB,
|  | magma_int_t | lddb,
|  | double | beta,
|  | magmaDoubleComplex_ptr | dC,
|  | magma_int_t | lddc,
|  | magma_queue_t | queue )

Perform Hermitian rank-2k update.

\( C = \alpha A B^H + \alpha B A^H \beta C \) (trans == MagmaNoTrans), or
\( C = \alpha A^H B + \alpha B^H A \beta C \) (trans == MagmaConjTrans),
where \( C \) is Hermitian.

Parameters

  [in] | uplo | Whether the upper or lower triangle of C is referenced.
  [in] | trans | Operation to perform on A and B.
  [in] | n | Number of rows and columns of C. n >= 0.
  [in] | k | Number of columns of A and B (for MagmaNoTrans) or rows of A and B (for MagmaConjTrans). k >= 0.
  [in] | alpha | Scalar \( \alpha \)
  [in] | dA | COMPLEX_16 array on GPU device. If trans == MagmaNoTrans, the n-by-k matrix A of dimension (ldda,k), ldda >= max(1,n); otherwise, the k-by-n matrix A of dimension (ldda,n), ldda >= max(1,k).
  [in] | ldda | Leading dimension of dA.
  [in] | dB | COMPLEX_16 array on GPU device. If trans == MagmaNoTrans, the n-by-k matrix B of dimension (lddb,k), lddb >= max(1,n); otherwise, the k-by-n matrix B of dimension (lddb,n), lddb >= max(1,k).
  [in] | lddb | Leading dimension of dB.
  [in] | beta | Scalar \( \beta \)
  [in,out] | dC | COMPLEX_16 array on GPU device. The n-by-n Hermitian matrix C of dimension (lddc,n), lddc >= max(1,n).
  [in] | lddc | Leading dimension of dC.
  [in] | queue | magma_queue_t Queue to execute in.

## magmablas_cher2k_mgpu2()

void magmablas_cher2k_mgpu2 | ( | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | magmaFloatComplex | alpha,
|  | magmaFloatComplex_ptr | dA[],
|  | magma_int_t | ldda,
|  | magma_int_t | a_offset,
|  | magmaFloatComplex_ptr | dB[],
|  | magma_int_t | lddb,
|  | magma_int_t | b_offset,
|  | float | beta,
|  | magmaFloatComplex_ptr | dC[],
|  | magma_int_t | lddc,
|  | magma_int_t | c_offset,
|  | magma_int_t | ngpu,
|  | magma_int_t | nb,
|  | magma_queue_t | queues[][20],
|  | magma_int_t | nqueue )

CHER2K performs one of the Hermitian rank 2k operations.

C := alpha*A*B**H + conjg( alpha )*B*A**H + beta*C,

or

C := alpha*A**H*B + conjg( alpha )*B**H*A + beta*C,

where alpha and beta are scalars with beta real, C is an n by n Hermitian matrix and A and B are n by k matrices in the first case and k by n matrices in the second case.

Parameters

  [in]

  uplo

  magma_uplo_t. On entry, UPLO specifies whether the upper or lower triangular part of the array C is to be referenced as follows:
  - = MagmaUpper: Only the upper triangular part of C is to be referenced.
  - = MagmaLower: Only the lower triangular part of C is to be referenced.

          current only Lower case is implemented.

  [in]

  trans

  magma_trans_t. On entry, TRANS specifies the operation to be performed as follows:
  - = MagmaNoTrans: C := alpha*A*B**H + conj( alpha )*B*A**H + beta*C.
  - = Magma_ConjTrans: C := alpha*A**H*B + conj( alpha )*B**H*A + beta*C.

          current only NoTrans case is implemented.

  [in] | n | INTEGER. On entry, N specifies the order of the matrix C. N must be at least zero.
  [in] | k | INTEGER. On entry with TRANS = MagmaNoTrans, K specifies the number of columns of the matrices A and B, and on entry with TRANS = Magma_ConjTrans, K specifies the number of rows of the matrices A and B. K must be at least zero.
  [in] | alpha | COMPLEX. On entry, ALPHA specifies the scalar alpha.
  [in] | dA | COMPLEX array of DIMENSION ( LDA, ka ), where ka is k when TRANS = MagmaNoTrans, and is n otherwise. Before entry with TRANS = MagmaNoTrans, the leading n by k part of the array A must contain the matrix A, otherwise the leading k by n part of the array A must contain the matrix A.

[TODO: describe distribution: duplicated on all GPUs.]

Parameters

  [in] | ldda | INTEGER. On entry, LDA specifies the first dimension of A as declared in the calling (sub) program. When TRANS = MagmaNoTrans then LDA must be at least max( 1, n ), otherwise LDA must be at least max( 1, k ).
  [in] | a_offset | INTEGER Row offset to start sub-matrix of dA. Uses dA(a_offset:a_offset+n, :). 0 <= a_offset < ldda.
  [in] | dB | COMPLEX array of DIMENSION ( LDB, kb ), where kb is k when TRANS = MagmaNoTrans, and is n otherwise. Before entry with TRANS = MagmaNoTrans, the leading n by k part of the array B must contain the matrix B, otherwise the leading k by n part of the array B must contain the matrix B.

[TODO: describe distribution: duplicated on all GPUs.]

Parameters

  [in] | lddb | INTEGER. On entry, LDB specifies the first dimension of B as declared in the calling (sub) program. When TRANS = MagmaNoTrans then LDB must be at least max( 1, n ), otherwise LDB must be at least max( 1, k ).
  [in] | b_offset | INTEGER Row offset to start sub-matrix of dB. Uses dB(b_offset:b_offset+n, :). 0 <= b_offset < lddb.
  [in] | beta | REAL. On entry, BETA specifies the scalar beta.

  [in,out]

  dC

  COMPLEX array of DIMENSION ( LDC, n ). Before entry with UPLO = MagmaUpper, the leading n by n upper triangular part of the array C must contain the upper triangular part of the Hermitian matrix and the strictly lower triangular part of C is not referenced. On exit, the upper triangular part of the array C is overwritten by the upper triangular part of the updated matrix.
  Before entry with UPLO = MagmaLower, the leading n by n lower triangular part of the array C must contain the lower triangular part of the Hermitian matrix and the strictly upper triangular part of C is not referenced. On exit, the lower triangular part of the array C is overwritten by the lower triangular part of the updated matrix.
  Note that the imaginary parts of the diagonal elements need not be set, they are assumed to be zero, and on exit they are set to zero. [TODO: verify]

[TODO: describe distribution: 1D column block-cyclic across GPUs.]

Parameters

  [in] | lddc | INTEGER. On entry, LDC specifies the first dimension of C as declared in the calling (sub) program. LDC must be at least max( 1, n ).
  [in] | c_offset | INTEGER. Row and column offset to start sub-matrix of dC. Uses dC(c_offset:c_offset+n, c_offset:c_offset+n). 0 <= c_offset < lddc.
  [in] | ngpu | INTEGER. Number of GPUs over which matrix C is distributed.
  [in] | nb | INTEGER. Block size used for distribution of C.
  [in] | queues | array of CUDA queues, of dimension NGPU by 20. Streams to use for running multiple GEMMs in parallel. Only up to NSTREAM queues are used on each GPU.
  [in] | nqueue | INTEGER. Number of queues to use on each device

## magmablas_dsyr2k_mgpu2()

void magmablas_dsyr2k_mgpu2 | ( | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | double | alpha,
|  | magmaDouble_ptr | dA[],
|  | magma_int_t | ldda,
|  | magma_int_t | a_offset,
|  | magmaDouble_ptr | dB[],
|  | magma_int_t | lddb,
|  | magma_int_t | b_offset,
|  | double | beta,
|  | magmaDouble_ptr | dC[],
|  | magma_int_t | lddc,
|  | magma_int_t | c_offset,
|  | magma_int_t | ngpu,
|  | magma_int_t | nb,
|  | magma_queue_t | queues[][20],
|  | magma_int_t | nqueue )

DSYR2K performs one of the symmetric rank 2k operations.

C := alpha*A*B**H + conjg( alpha )*B*A**H + beta*C,

or

C := alpha*A**H*B + conjg( alpha )*B**H*A + beta*C,

where alpha and beta are scalars with beta real, C is an n by n symmetric matrix and A and B are n by k matrices in the first case and k by n matrices in the second case.

Parameters

  [in]

  uplo

  magma_uplo_t. On entry, UPLO specifies whether the upper or lower triangular part of the array C is to be referenced as follows:
  - = MagmaUpper: Only the upper triangular part of C is to be referenced.
  - = MagmaLower: Only the lower triangular part of C is to be referenced.

          current only Lower case is implemented.

  [in]

  trans

  magma_trans_t. On entry, TRANS specifies the operation to be performed as follows:
  - = MagmaNoTrans: C := alpha*A*B**H + conj( alpha )*B*A**H + beta*C.
  - = MagmaTrans: C := alpha*A**H*B + conj( alpha )*B**H*A + beta*C.

          current only NoTrans case is implemented.

  [in] | n | INTEGER. On entry, N specifies the order of the matrix C. N must be at least zero.
  [in] | k | INTEGER. On entry with TRANS = MagmaNoTrans, K specifies the number of columns of the matrices A and B, and on entry with TRANS = MagmaTrans, K specifies the number of rows of the matrices A and B. K must be at least zero.
  [in] | alpha | DOUBLE PRECISION. On entry, ALPHA specifies the scalar alpha.
  [in] | dA | DOUBLE PRECISION array of DIMENSION ( LDA, ka ), where ka is k when TRANS = MagmaNoTrans, and is n otherwise. Before entry with TRANS = MagmaNoTrans, the leading n by k part of the array A must contain the matrix A, otherwise the leading k by n part of the array A must contain the matrix A.

[TODO: describe distribution: duplicated on all GPUs.]

Parameters

  [in] | ldda | INTEGER. On entry, LDA specifies the first dimension of A as declared in the calling (sub) program. When TRANS = MagmaNoTrans then LDA must be at least max( 1, n ), otherwise LDA must be at least max( 1, k ).
  [in] | a_offset | INTEGER Row offset to start sub-matrix of dA. Uses dA(a_offset:a_offset+n, :). 0 <= a_offset < ldda.
  [in] | dB | DOUBLE PRECISION array of DIMENSION ( LDB, kb ), where kb is k when TRANS = MagmaNoTrans, and is n otherwise. Before entry with TRANS = MagmaNoTrans, the leading n by k part of the array B must contain the matrix B, otherwise the leading k by n part of the array B must contain the matrix B.

[TODO: describe distribution: duplicated on all GPUs.]

Parameters

  [in] | lddb | INTEGER. On entry, LDB specifies the first dimension of B as declared in the calling (sub) program. When TRANS = MagmaNoTrans then LDB must be at least max( 1, n ), otherwise LDB must be at least max( 1, k ).
  [in] | b_offset | INTEGER Row offset to start sub-matrix of dB. Uses dB(b_offset:b_offset+n, :). 0 <= b_offset < lddb.
  [in] | beta | DOUBLE PRECISION. On entry, BETA specifies the scalar beta.

  [in,out]

  dC

  DOUBLE PRECISION array of DIMENSION ( LDC, n ). Before entry with UPLO = MagmaUpper, the leading n by n upper triangular part of the array C must contain the upper triangular part of the symmetric matrix and the strictly lower triangular part of C is not referenced. On exit, the upper triangular part of the array C is overwritten by the upper triangular part of the updated matrix.
  Before entry with UPLO = MagmaLower, the leading n by n lower triangular part of the array C must contain the lower triangular part of the symmetric matrix and the strictly upper triangular part of C is not referenced. On exit, the lower triangular part of the array C is overwritten by the lower triangular part of the updated matrix.
  Note that the imaginary parts of the diagonal elements need not be set, they are assumed to be zero, and on exit they are set to zero. [TODO: verify]

[TODO: describe distribution: 1D column block-cyclic across GPUs.]

Parameters

  [in] | lddc | INTEGER. On entry, LDC specifies the first dimension of C as declared in the calling (sub) program. LDC must be at least max( 1, n ).
  [in] | c_offset | INTEGER. Row and column offset to start sub-matrix of dC. Uses dC(c_offset:c_offset+n, c_offset:c_offset+n). 0 <= c_offset < lddc.
  [in] | ngpu | INTEGER. Number of GPUs over which matrix C is distributed.
  [in] | nb | INTEGER. Block size used for distribution of C.
  [in] | queues | array of CUDA queues, of dimension NGPU by 20. Streams to use for running multiple GEMMs in parallel. Only up to NSTREAM queues are used on each GPU.
  [in] | nqueue | INTEGER. Number of queues to use on each device

## magmablas_ssyr2k_mgpu2()

void magmablas_ssyr2k_mgpu2 | ( | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | float | alpha,
|  | magmaFloat_ptr | dA[],
|  | magma_int_t | ldda,
|  | magma_int_t | a_offset,
|  | magmaFloat_ptr | dB[],
|  | magma_int_t | lddb,
|  | magma_int_t | b_offset,
|  | float | beta,
|  | magmaFloat_ptr | dC[],
|  | magma_int_t | lddc,
|  | magma_int_t | c_offset,
|  | magma_int_t | ngpu,
|  | magma_int_t | nb,
|  | magma_queue_t | queues[][20],
|  | magma_int_t | nqueue )

SSYR2K performs one of the symmetric rank 2k operations.

C := alpha*A*B**H + conjg( alpha )*B*A**H + beta*C,

or

C := alpha*A**H*B + conjg( alpha )*B**H*A + beta*C,

where alpha and beta are scalars with beta real, C is an n by n symmetric matrix and A and B are n by k matrices in the first case and k by n matrices in the second case.

Parameters

  [in]

  uplo

  magma_uplo_t. On entry, UPLO specifies whether the upper or lower triangular part of the array C is to be referenced as follows:
  - = MagmaUpper: Only the upper triangular part of C is to be referenced.
  - = MagmaLower: Only the lower triangular part of C is to be referenced.

          current only Lower case is implemented.

  [in]

  trans

  magma_trans_t. On entry, TRANS specifies the operation to be performed as follows:
  - = MagmaNoTrans: C := alpha*A*B**H + conj( alpha )*B*A**H + beta*C.
  - = MagmaTrans: C := alpha*A**H*B + conj( alpha )*B**H*A + beta*C.

          current only NoTrans case is implemented.

  [in] | n | INTEGER. On entry, N specifies the order of the matrix C. N must be at least zero.
  [in] | k | INTEGER. On entry with TRANS = MagmaNoTrans, K specifies the number of columns of the matrices A and B, and on entry with TRANS = MagmaTrans, K specifies the number of rows of the matrices A and B. K must be at least zero.
  [in] | alpha | REAL. On entry, ALPHA specifies the scalar alpha.
  [in] | dA | REAL array of DIMENSION ( LDA, ka ), where ka is k when TRANS = MagmaNoTrans, and is n otherwise. Before entry with TRANS = MagmaNoTrans, the leading n by k part of the array A must contain the matrix A, otherwise the leading k by n part of the array A must contain the matrix A.

[TODO: describe distribution: duplicated on all GPUs.]

Parameters

  [in] | ldda | INTEGER. On entry, LDA specifies the first dimension of A as declared in the calling (sub) program. When TRANS = MagmaNoTrans then LDA must be at least max( 1, n ), otherwise LDA must be at least max( 1, k ).
  [in] | a_offset | INTEGER Row offset to start sub-matrix of dA. Uses dA(a_offset:a_offset+n, :). 0 <= a_offset < ldda.
  [in] | dB | REAL array of DIMENSION ( LDB, kb ), where kb is k when TRANS = MagmaNoTrans, and is n otherwise. Before entry with TRANS = MagmaNoTrans, the leading n by k part of the array B must contain the matrix B, otherwise the leading k by n part of the array B must contain the matrix B.

[TODO: describe distribution: duplicated on all GPUs.]

Parameters

  [in] | lddb | INTEGER. On entry, LDB specifies the first dimension of B as declared in the calling (sub) program. When TRANS = MagmaNoTrans then LDB must be at least max( 1, n ), otherwise LDB must be at least max( 1, k ).
  [in] | b_offset | INTEGER Row offset to start sub-matrix of dB. Uses dB(b_offset:b_offset+n, :). 0 <= b_offset < lddb.
  [in] | beta | REAL. On entry, BETA specifies the scalar beta.

  [in,out]

  dC

  REAL array of DIMENSION ( LDC, n ). Before entry with UPLO = MagmaUpper, the leading n by n upper triangular part of the array C must contain the upper triangular part of the symmetric matrix and the strictly lower triangular part of C is not referenced. On exit, the upper triangular part of the array C is overwritten by the upper triangular part of the updated matrix.
  Before entry with UPLO = MagmaLower, the leading n by n lower triangular part of the array C must contain the lower triangular part of the symmetric matrix and the strictly upper triangular part of C is not referenced. On exit, the lower triangular part of the array C is overwritten by the lower triangular part of the updated matrix.
  Note that the imaginary parts of the diagonal elements need not be set, they are assumed to be zero, and on exit they are set to zero. [TODO: verify]

[TODO: describe distribution: 1D column block-cyclic across GPUs.]

Parameters

  [in] | lddc | INTEGER. On entry, LDC specifies the first dimension of C as declared in the calling (sub) program. LDC must be at least max( 1, n ).
  [in] | c_offset | INTEGER. Row and column offset to start sub-matrix of dC. Uses dC(c_offset:c_offset+n, c_offset:c_offset+n). 0 <= c_offset < lddc.
  [in] | ngpu | INTEGER. Number of GPUs over which matrix C is distributed.
  [in] | nb | INTEGER. Block size used for distribution of C.
  [in] | queues | array of CUDA queues, of dimension NGPU by 20. Streams to use for running multiple GEMMs in parallel. Only up to NSTREAM queues are used on each GPU.
  [in] | nqueue | INTEGER. Number of queues to use on each device

## magmablas_zher2k_mgpu2()

void magmablas_zher2k_mgpu2 | ( | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | magmaDoubleComplex | alpha,
|  | magmaDoubleComplex_ptr | dA[],
|  | magma_int_t | ldda,
|  | magma_int_t | a_offset,
|  | magmaDoubleComplex_ptr | dB[],
|  | magma_int_t | lddb,
|  | magma_int_t | b_offset,
|  | double | beta,
|  | magmaDoubleComplex_ptr | dC[],
|  | magma_int_t | lddc,
|  | magma_int_t | c_offset,
|  | magma_int_t | ngpu,
|  | magma_int_t | nb,
|  | magma_queue_t | queues[][20],
|  | magma_int_t | nqueue )

ZHER2K performs one of the Hermitian rank 2k operations.

C := alpha*A*B**H + conjg( alpha )*B*A**H + beta*C,

or

C := alpha*A**H*B + conjg( alpha )*B**H*A + beta*C,

where alpha and beta are scalars with beta real, C is an n by n Hermitian matrix and A and B are n by k matrices in the first case and k by n matrices in the second case.

Parameters

  [in]

  uplo

  magma_uplo_t. On entry, UPLO specifies whether the upper or lower triangular part of the array C is to be referenced as follows:
  - = MagmaUpper: Only the upper triangular part of C is to be referenced.
  - = MagmaLower: Only the lower triangular part of C is to be referenced.

          current only Lower case is implemented.

  [in]

  trans

  magma_trans_t. On entry, TRANS specifies the operation to be performed as follows:
  - = MagmaNoTrans: C := alpha*A*B**H + conj( alpha )*B*A**H + beta*C.
  - = Magma_ConjTrans: C := alpha*A**H*B + conj( alpha )*B**H*A + beta*C.

          current only NoTrans case is implemented.

  [in] | n | INTEGER. On entry, N specifies the order of the matrix C. N must be at least zero.
  [in] | k | INTEGER. On entry with TRANS = MagmaNoTrans, K specifies the number of columns of the matrices A and B, and on entry with TRANS = Magma_ConjTrans, K specifies the number of rows of the matrices A and B. K must be at least zero.
  [in] | alpha | COMPLEX*16. On entry, ALPHA specifies the scalar alpha.
  [in] | dA | COMPLEX*16 array of DIMENSION ( LDA, ka ), where ka is k when TRANS = MagmaNoTrans, and is n otherwise. Before entry with TRANS = MagmaNoTrans, the leading n by k part of the array A must contain the matrix A, otherwise the leading k by n part of the array A must contain the matrix A.

[TODO: describe distribution: duplicated on all GPUs.]

Parameters

  [in] | ldda | INTEGER. On entry, LDA specifies the first dimension of A as declared in the calling (sub) program. When TRANS = MagmaNoTrans then LDA must be at least max( 1, n ), otherwise LDA must be at least max( 1, k ).
  [in] | a_offset | INTEGER Row offset to start sub-matrix of dA. Uses dA(a_offset:a_offset+n, :). 0 <= a_offset < ldda.
  [in] | dB | COMPLEX*16 array of DIMENSION ( LDB, kb ), where kb is k when TRANS = MagmaNoTrans, and is n otherwise. Before entry with TRANS = MagmaNoTrans, the leading n by k part of the array B must contain the matrix B, otherwise the leading k by n part of the array B must contain the matrix B.

[TODO: describe distribution: duplicated on all GPUs.]

Parameters

  [in] | lddb | INTEGER. On entry, LDB specifies the first dimension of B as declared in the calling (sub) program. When TRANS = MagmaNoTrans then LDB must be at least max( 1, n ), otherwise LDB must be at least max( 1, k ).
  [in] | b_offset | INTEGER Row offset to start sub-matrix of dB. Uses dB(b_offset:b_offset+n, :). 0 <= b_offset < lddb.
  [in] | beta | DOUBLE PRECISION. On entry, BETA specifies the scalar beta.

  [in,out]

  dC

  COMPLEX*16 array of DIMENSION ( LDC, n ). Before entry with UPLO = MagmaUpper, the leading n by n upper triangular part of the array C must contain the upper triangular part of the Hermitian matrix and the strictly lower triangular part of C is not referenced. On exit, the upper triangular part of the array C is overwritten by the upper triangular part of the updated matrix.
  Before entry with UPLO = MagmaLower, the leading n by n lower triangular part of the array C must contain the lower triangular part of the Hermitian matrix and the strictly upper triangular part of C is not referenced. On exit, the lower triangular part of the array C is overwritten by the lower triangular part of the updated matrix.
  Note that the imaginary parts of the diagonal elements need not be set, they are assumed to be zero, and on exit they are set to zero. [TODO: verify]

[TODO: describe distribution: 1D column block-cyclic across GPUs.]

Parameters

  [in] | lddc | INTEGER. On entry, LDC specifies the first dimension of C as declared in the calling (sub) program. LDC must be at least max( 1, n ).
  [in] | c_offset | INTEGER. Row and column offset to start sub-matrix of dC. Uses dC(c_offset:c_offset+n, c_offset:c_offset+n). 0 <= c_offset < lddc.
  [in] | ngpu | INTEGER. Number of GPUs over which matrix C is distributed.
  [in] | nb | INTEGER. Block size used for distribution of C.
  [in] | queues | array of CUDA queues, of dimension NGPU by 20. Streams to use for running multiple GEMMs in parallel. Only up to NSTREAM queues are used on each GPU.
  [in] | nqueue | INTEGER. Number of queues to use on each device